Attribute VB_Name = "Module2"
Option Explicit

Private Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal strBufferLength As Long, ByVal lpBuffer As String) As Long

'file header, total 14 bytes
Private Type WINBMPFILEHEADER
     strFileType As String * 2 ' file type always 4D42h or "BM"
     lngFileSize As Long       ' file size in bytes
     bytReserved1 As Integer   ' always 0
     bytReserved2 As Integer   ' always 0
     lngBitmapOffset As Long   ' starting position of image data in bytes
End Type

'image header, total 40 bytes
Private Type BITMAPINFOHEADER
     biSize As Long          ' size of this header
     biWidth As Long         ' width of your image
     biHeight As Long        ' height of your image
     biPlanes As Integer     ' always 1
     byBitCount As Integer   ' number of bits per pixel 1, 4, 8, or 24
     biCompression As Long   ' 0: data is not compressed
     biSizeImage As Long     ' size of bitmap in bytes
     biXPelsPerMeter As Long ' preferred resolution in pixels per meter
     biYPelsPerMeter As Long ' preferred resolution in pixels per meter
     biClrUsed As Long       ' number of colors that are actually used (can be 0)
     biClrImportant As Long  ' which color is most important (0 means all of them)
End Type

Private Function CreateTempFile(strPrefix As String) As String

Dim strBuffer As String
Dim nRetVal As Long
Dim lngPos As Long
Dim strTempDir As String
  
strTempDir = GetTempDir
strTempDir = strTempDir & IIf(Right$(strTempDir, 1) = "\", "", "\")

strBuffer = Space(255)
nRetVal = GetTempFileName(strTempDir, Left$(strPrefix, 3), 0&, strBuffer)

If nRetVal <> 0 Then
    lngPos = InStr(strBuffer, Chr$(0))
    If lngPos = 0 Then
        CreateTempFile = strBuffer
    Else
        CreateTempFile = Left(strBuffer, lngPos - 1)
    End If
End If

End Function

Private Function GetTempDir() As String
  
Dim strBuffer As String
Dim nRetVal As Long
Dim strPath As String

strBuffer = Space(255)
nRetVal = GetTempPath(255, strBuffer)

If nRetVal > 0 Then
    strPath = Left$(strBuffer, nRetVal)
Else
    strPath = CurDir$
End If

GetTempDir = strPath
  
End Function

Private Sub CreateImage(FileName As String, Width As Long, Height As Long)
          
Dim BMPHeader As WINBMPFILEHEADER
Dim BMPInfo As BITMAPINFOHEADER

Dim RawData() As Byte
ReDim RawData(1 To (3 * Width * Height) + ((Width Mod 4) * Height)) As Byte

Dim FileNum As Integer

BMPHeader.strFileType = "BM"
BMPHeader.lngFileSize = (3 * Width * Height) + ((Width Mod 4) * Height) + 54
BMPHeader.bytReserved1 = 0
BMPHeader.bytReserved2 = 0
BMPHeader.lngBitmapOffset = 54

BMPInfo.biSize = 40
BMPInfo.biWidth = Width
BMPInfo.biHeight = Height
BMPInfo.biPlanes = 1
BMPInfo.byBitCount = 24
BMPInfo.biCompression = 0
BMPInfo.biSizeImage = (3 * Width * Height) + ((Width Mod 4) * Height)
BMPInfo.biXPelsPerMeter = 3780
BMPInfo.biYPelsPerMeter = 3780
BMPInfo.biClrUsed = 0
BMPInfo.biClrImportant = 0

FileNum = FreeFile
Open FileName For Binary As FileNum
    Put FileNum, , BMPHeader
    Put FileNum, , BMPInfo
    Put FileNum, , RawData
Close

End Sub

Public Function MakeBitmap(Width As Long, Height As Long) As String

Dim FileName As String

FileName = CreateTempFile("PLA")

Kill FileName

Call CreateImage(FileName, Width, Height)

MakeBitmap = FileName

End Function
